/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.math.BigInteger;
import java.rmi.Naming;
import java.util.Scanner;

/**
 *
 * @author Thomas
 */
public class Client {

    public Client() {
        try {
            System.out.println();
            System.out.println();

            Scanner in = new Scanner(System.in);
            while (true) {
                String host = "localhost";
                String username = "";
                String password = "";

                //System.out.println("Host:");
                //user = in.nextLine();
                System.out.println("Username:");
                username = in.nextLine();

                System.out.println("Password:");
                password = in.nextLine();
                //in.close();

                // Get a stub for the Impl object (the stub implements the interface).
                ICommon obj = (ICommon) Naming.lookup("rmi://" + host + ":" + ICommon.port + "/" + ICommon.serviceName);


                //Request challenge
                BigInteger challenge = obj.challenge();
                System.out.println();
                System.out.println("==================================================");
                System.out.println("Received challenge:");
                System.out.println(challenge);
                System.out.println();

                try {
                    Thread.sleep(2000);
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }

                //Generate response using provided challenge
                BigInteger response = Utils.generateResponse(username, password, challenge);
                System.out.println("Calculated response:");
                System.out.println(response);
                Thread.sleep(1000); //simmulate slow reaction time
                boolean success = obj.response(response);

                System.out.println();
                System.out.println();
                System.out.println("Login success: " + success);
                System.out.println("==================================================");
                System.out.println();
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
