
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Date;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Thomas
 */
public class Utils {

    public static BigInteger generateResponse(String username, String password, BigInteger challenge) throws NoSuchAlgorithmException {
        MessageDigest md = MessageDigest.getInstance("MD5");
        md.update((username + password + challenge + createTimestamp().getTime()).getBytes());
        return new BigInteger(md.digest());
    }

    //Create time stamp that is rounded to a predefined accuracy
    private static Date createTimestamp() {
        int precision = 5;
        Date d1 = new Date();
        d1.setSeconds(0);

        long mod = d1.getTime() % (precision * 1000 * 60);

        if (mod < ((precision * 1000 * 60) / 2)) {
            d1.setTime(d1.getTime() - mod);
        } else {
            d1.setTime(d1.getTime() + ((precision * 1000 * 60) - mod));
        }
        return d1;
    }
}
